<?php

/******************************************************************
 If you want to use Akismet for spam protection, enter your Akismet
 API key below. 
 ******************************************************************/

$AKISMET_API_KEY = "REPLACE THIS WITH YOUR KEY";

/*
Cruciforum, v 1.26, October 2007
Stuart Langridge, http://www.kryogenix.org/

Installation:
1. Save cruciforum.php into an empty folder in your webspace
2. Visit it in your web browser
3. That's it.

See http://www.kryogenix.org/code/cruciforum/ for more.

*/

/******************************************************************
 You can stop editing now.
 ******************************************************************/

$THREADS_PER_LIST_PAGE = 100;
$VERSION = "1.26"; // updating this also means updating the meta generator tags
if (file_exists("forumname")) {
  $FORUMNAME = file_get_contents("forumname");
} else {
  $FORUMNAME = "Discussion forum";
}
$FROMTR = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ@.-_";
$TOTR   = ".UfS@XLjstlv-gMwBWOnoq_dDRpFzEAyrVYHCNahKxQmJekucbTPGZIi";

// Textile defines
@define('txt_quote_single_open',  '&#8216;');
@define('txt_quote_single_close', '&#8217;');
@define('txt_quote_double_open',  '&#8220;');
@define('txt_quote_double_close', '&#8221;');
@define('txt_apostrophe',         '&#8217;');
@define('txt_prime',              '&#8242;');
@define('txt_prime_double',       '&#8243;');
@define('txt_ellipsis',           '&#8230;');
@define('txt_emdash',             '&#8212;');
@define('txt_endash',             '&#8211;');
@define('txt_dimension',          '&#215;');
@define('txt_trademark',          '&#8482;');
@define('txt_registered',         '&#174;');
@define('txt_copyright',          '&#169;');


if (!function_exists('file_put_contents')) {
    function file_put_contents($filename, $data) {
        $f = @fopen($filename, 'w');
        if (!$f) {
            return false;
        } else {
            $bytes = fwrite($f, $data);
            fclose($f);
            return $bytes;
        }
    }
}

if (!function_exists('file_get_contents')) {

    // Define function and arguments
    function file_get_contents($file, $include=false)
    {
        // Varify arguments are correct types
        if (!is_string($file))  return(false);
        if (!is_bool($include)) return(false);
        
        // Open the file with givin options
        if (!$handle = @fopen($file, 'rb', $include)) return(false);
        // Read data from file
        $contents = fread($handle, filesize($file));
        // Close file
        fclose($handle);
        
        // Return contents of file
        return($contents);
    }
} 

$files = Array(
  "themes/selected/cruciforum.js" => <<<__EOF



cruciforum = {
  init: function() {
    cruciforum.hideUsernamesOnThreadList();
    cruciforum.hijackSubmitMethod();
    cruciforum.loadSavedUserDetails();
    cruciforum.focusTextArea();
  },
  
  focusTextArea: function() {
    var tas = document.getElementsByTagName('textarea');
    if (tas.length > 0) {
      tas[0].focus();
      tas[0].onkeypress = function() {
        // enable submit button!
        var inps = document.getElementsByTagName('input');
        for (var j=0; j<inps.length; j++) {
          if (inps[j].type == "submit") {
            inps[j].value = inps[j].original_value;
            inps[j].disabled = false;
          }
        }
      }
    }
  },
  
  hijackSubmitMethod: function() {
    var forms = document.getElementsByTagName('form');
    for (var i=0; i<forms.length; i++) {
      if (forms[i].className == "postform") {
        forms[i].onsubmit = function() {
          var name = document.getElementById('name');
          var website = document.getElementById('website');
          var email = document.getElementById('email');
          cruciforum.createCookie("cruciforum_name",name.value,180);
          cruciforum.createCookie("cruciforum_website",website.value,180);
          cruciforum.createCookie("cruciforum_email",email.value,180);          
        }
        // disable submit until textarea is filled in
        var inps = document.getElementsByTagName('input');
        for (var j=0; j<inps.length; j++) {
          if (inps[j].type == "submit") {
            inps[j].original_value = inps[j].value;
            inps[j].value = "Enter a message!";
            inps[j].disabled = true;
          }
        }
      }
    }
  },
  
  loadSavedUserDetails: function() {
    var name = document.getElementById('name');
    var website = document.getElementById('website');
    var email = document.getElementById('email');
    if (name && website && email) {
      name.value = cruciforum.readCookie("cruciforum_name");
      website.value = cruciforum.readCookie("cruciforum_website");
      email.value = cruciforum.readCookie("cruciforum_email");
    }
  },
  
  hideUsernamesOnThreadList: function() {
    cruciforum.createCSS("li.threadlink span","display: none");  
    var lis = document.getElementsByTagName("li");
    for (var i=0; i<lis.length; i++) {
      if (lis[i].className == "threadlink") {
        var a = lis[i].getElementsByTagName('a')[0];
        // closures
        a.onmouseover = (function(a) {
          return function() {
            var spans = a.parentNode.getElementsByTagName("span");
            for (var j=0; j<spans.length; j++) {
              spans[j].style.display = "inline";
            }
          }
        })(a);
        a.onmouseout = (function(a) {
          return function() {
            var spans = a.parentNode.getElementsByTagName("span");
            for (var j=0; j<spans.length; j++) {
              spans[j].style.display = "none";
            }
          }
        })(a);
      }
    }
  },

  createCSS: function(selector, declaration) {
  	// test for IE
  	var ua = navigator.userAgent.toLowerCase();
  	var isIE = (/msie/.test(ua)) && !(/opera/.test(ua)) && (/win/.test(ua));

  	// create the style node for all browsers
  	var style_node = document.createElement("style");
  	style_node.setAttribute("type", "text/css");
  	style_node.setAttribute("media", "screen"); 

  	// append a rule for good browsers
  	if (!isIE) style_node.appendChild(document.createTextNode(selector + " {" + declaration + "}"));

  	// append the style node
  	document.getElementsByTagName("head")[0].appendChild(style_node);

  	// use alternative methods for IE
  	if (isIE && document.styleSheets && document.styleSheets.length > 0) {
  		var last_style_node = document.styleSheets[document.styleSheets.length - 1];
  		if (typeof(last_style_node.addRule) == "object") last_style_node.addRule(selector, declaration);
  	}
  },

  createCookie: function (name,value,days) {
  	if (days) {
  		var date = new Date();
  		date.setTime(date.getTime()+(days*24*60*60*1000));
  		var expires = "; expires="+date.toGMTString();
  	}
  	else var expires = "";
  	document.cookie = name+"="+value+expires+"; path=/";
  },

  readCookie: function(name) {
  	var nameEQ = name + "=";
  	var ca = document.cookie.split(';');
  	for(var i=0;i < ca.length;i++) {
  		var c = ca[i];
  		while (c.charAt(0)==' ') c = c.substring(1,c.length);
  		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
  	}
  	return null;
  },

  eraseCookie: function(name) {
  	createCookie(name,"",-1);
  }  
};

/* DOMContentLoaded: http://www.kryogenix.org/days/2007/09/26/shortloaded */
(function(i) {
var u =navigator.userAgent;
var e=/*@cc_on!@*/false; var st =setTimeout;
if(/webkit/i.test(u)){st(function(){var dr=document.readyState;
if(dr=="loaded"||dr=="complete"){i()}else{st(arguments.callee,10);}},10);}
else if((/mozilla/i.test(u)&&!/(compati)/.test(u)) || (/opera/i.test(u))){
document.addEventListener("DOMContentLoaded",i,false); } else if(e){     (
function(){var t=document.createElement('doc:rdy');try{t.doScroll('left');
i();t=null;}catch(e){st(arguments.callee,0);}})();}else{window.onload=i;}})(cruciforum.init);

  
  
  
__EOF
, 
  "themes/selected/cruciforum.css" => <<<__EOF
body { 
  color: #343; 
  background-color: #cec; 
  font-family: "Lucida Bright", Lucidabright, Georgia,
    "Bitstream Vera Serif", serif; /* http://clagnut.com/blog/266/ */
}
h1 {
  background: #bdb;
  margin: 0 0 1em 0;
  padding: 0.3em;
}
#posts dt { clear: left;  }
#posts dt p { margin: 0; font-size: 10px; display: inline; color: #666;
}
#posts dt p a { color: #66c;}
#posts dd { padding-left: 43px; float: left; margin: 0; 
min-height: 30px; }
#posts dd p { margin-top: 0; }
p.gravatar img { position: relative; top: 32px;  }
#nav { clear: left; padding-top: 1em; text-align: center; }
#nav p { display: inline; border: 1px solid #666; border-width: 0 1px; 
padding: 0 5px; }

#threads, #threads li {
  list-style: none;
  margin: 0;
  padding: 0;
}
#threads li a {
  padding-left: 20px;
  background-color: #bdb;
}
#threads li a:visited {
  background-color: #cec;
}

label { 
  float: left;
  clear: left;
  width: 10em; 
}
input, textarea {
  border: 2px solid #666;
  padding: 0.5em;
  width: 25em;
}
.postform p.submit { margin-left: 10em; }
p.submit input { 
  width: auto; 
  border-style: outset;
}

.postform p { margin: 1em 0 0 0; }

.postform p.note {
  margin-left: 14.28em; /* 10em / 0.7em */ 
  margin-top: 0;
  font-size: 0.7em;
}
p.note, p.note a {
  color: #999;
}

__EOF
, 
  "list.tmpl" => <<<__EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta name="generator" value="Cruciforum 1.26">
<title>{{FORUMNAME}}</title>
<link rel="stylesheet" href="themes/selected/cruciforum.css">
<script type="text/javascript" src="themes/selected/cruciforum.js"></script>
</head>
<body>
<h1>{{FORUMNAME}}</h1>
<ul id="threads">
</ul>
<div id="nav">
<p><a href="new.html">Start a new topic</a></p>
<p><a id="prev" href="{{PREVPAGE}}">previous posts</a></p>
</div>
</body>
</html>
__EOF
, 
  "thread.tmpl" => <<<__EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta name="generator" value="Cruciforum 1.26">
<title>{{THREADTITLE}} : {{FORUMNAME}}</title>
<link rel="stylesheet" href="../../themes/selected/cruciforum.css">
<script type="text/javascript" src="../../themes/selected/cruciforum.js"></script>
</head>
<body>
<h1>{{THREADTITLE}} - {{FORUMNAME}}</h1>
<dl id="posts">
{{FIRSTPOST}}
</dl>
<div id="nav">
<p><a href="tpost{{THREADID}}.html">Reply</a></p>
<p><a href="../../index.html">Back to the list</a></p>
</div>
</body>
</html>
__EOF
,
  "new.html" => <<<__EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta name="generator" value="Cruciforum 1.26">
<title>{{FORUMNAME}}</title>
<link rel="stylesheet" href="themes/selected/cruciforum.css">
<script type="text/javascript" src="themes/selected/cruciforum.js"></script>
</head>
<body>
<h1>Start a new topic</h1>
<form method="POST" action="cruciforum.php" id="newthread" class="postform">
<input type="hidden" name="action" value="newthread">
  <div id="ta">
    <label for="text">Message:</label>
    <textarea name="text" id="text" rows="5" cols="40"></textarea>
    <p class="note">HTML will not be interpreted. Use <a 
    href="http://textile.thresholdstate.com/">Textile</a> to get formatting.</p>
  </div>
  <p><label for="threadsubject">Your new topic title:</label> <input type="text" 
  id="threadsubject" name="threadsubject"></p>
  <div id="aboutyou">
  <h2>About you</h2>
  <p><label for="name">Name:</label> <input type="text" name="name" id="name"></p>
  <p class="note">Not required, but it's sensible to put it in</p>
  <p><label for="website">Website:</label> <input type="text" name="website" id="website"></p>
  <p class="note">Not required</p>
  <p><label for="email">Email:</label> <input type="text" name="email" id="email"></p>
  <p class="note">Not required: obscured on the page, available so you can be emailed, and to get a 
  <a href="http://site.gravatar.com/">Gravatar</a></p>
  </div>
  <p class="submit"><input type="submit" value="Post new topic"></p>
</form>
<p><a href="index.html">Back to the list</a></p>
</body>
</html>
__EOF
,
  "tpost.tmpl" => <<<__EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta name="generator" value="Cruciforum 1.26">
<title>{{THREADTITLE}} - {{FORUMNAME}}</title>
<link rel="stylesheet" href="../../themes/selected/cruciforum.css">
<script type="text/javascript" src="../../themes/selected/cruciforum.js"></script>
</head>
<body>
<h1>Reply to {{THREADTITLE}}</h1>
<form method="POST" action="../../cruciforum.php" id="newpost" class="postform">
  <p><input type="hidden" name="action" value="newpost">
  <input type="hidden" name="thread" value="{{THREADID}}">
  <div id="ta">
    <label for="text">Message:</label>
    <textarea name="text" id="text" rows="5" cols="40"></textarea>
    <p class="note">HTML will not be interpreted. Use <a 
    href="http://textile.thresholdstate.com/">Textile</a> to get formatting.</p>
  </div>
  <div id="aboutyou">
  <h2>About you</h2>
  <p><label for="name">Name:</label> <input type="text" name="name" id="name"></p>
  <p class="note">Not required, but it's sensible to put it in</p>
  <p><label for="website">Website:</label> <input type="text" name="website" id="website"></p>
  <p class="note">Not required</p>
  <p><label for="email">Email:</label> <input type="text" name="email" id="email"></p>
  <p class="note">Not required: obscured on the page, available so you can be emailed, and to get a 
  <a href="http://site.gravatar.com/">Gravatar</a></p>
  <p class="submit"><input type="submit" value="Post to topic"></p>
  </div>
</form>
<div id="nav">
<p><a href="t{{THREADID}}.html">Back to the topic</a></p>
<p><a href="../../index.html">Back to the list</a></p>
</div>
</body>
</html>
__EOF
);
$extras = Array(
  "installation_header" => <<<__EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>Installing Cruciforum</title>
<style type="text/css">
body { 
  color: #343; 
  background-color: #cec; 
  font-family: "Lucida Bright", Lucidabright, Georgia,
    "Bitstream Vera Serif", serif; /* http://clagnut.com/blog/266/ */
}
h1 {
  background: #bdb;
  margin: 0 0 1em 0;
  padding: 0.3em;
}
input, textarea {
  border: 2px solid #666;
  padding: 0.5em;
  width: 25em;
}
p.forumnameinput, p.submit { text-align: center; }
p.submit input { 
  width: auto; 
  border-style: outset;
}

.fail { color: red; }
</style>
<script type="text/javascript">
window.onload = function() {
  if (document.getElementById('forumname')) {
    document.getElementById('forumname').focus();
    document.getElementById('forumname').select();
  }
}
</script>
</head>
<body>
<h1>Installing Cruciforum</h1>
<p>Welcome to Cruciforum! The installation process will now run.</p>
__EOF
,
  "thread_page_post" => <<<__EOF
<dt>
  <p class="gravatar"><img src="http://www.gravatar.com/avatar.php?gravatar_id={{EMAILMD5}}&amp;size=40" alt=""></p>
  <p>Author: {{NAME}}</p>
  <p>Web: {{WEBSITE}}</p>
  <p>Email: {{EMAIL}}</p>
  <p>(<a href="../../cruciforum.php?action=search&amp;user={{NAME}}">all posts by {{NAME}}</a>)</p>
  <p>When: <a href="#d{{DATE}}" name="d{{DATE}}">{{DATE}}</a></p>
</dt>
<dd>{{TEXT}}</dd>
__EOF
,
  "index_page_link" => <<<__EOF
<li class="threadlink"><a href="{{THREADFILE}}?replies=0">{{THREADTITLE}}</a> 
<span class="byname">by {{NAME}}</span>
<span class="attime">on {{DATE}}</span>
</li>
__EOF
,
  "ask_for_forum_name" => <<<__EOF
<form method="POST">
<input type="hidden" name="action" value="install">
<h2>Please choose a name for your forum!</h2>
<p class="forumnameinput"><input type="text" name="forumname" id="forumname"
value="Discussion forum" size="30"></p>
<p class="submit"><input type="submit" value="Install Cruciforum">
</form>
</body>
</html>
__EOF
);

$action = $_REQUEST["action"];
if (!isset($action)) $action = "check_install";

if ($action != "upgrade") check_if_upgrade_required();

switch ($action) {
  case "check_install": check_install(); break;
  case "install": install(); break;
  case "newthread": newthread(); break;
  case "newpost": newpost(); break;
  case "search": search(); break;
  case "email": email(); break;
  case "upgrade": upgrade(); break;
  default: badcall();
}

function check_if_upgrade_required() {
  if (!file_exists("list.tmpl")) return;
  $fromto = get_upgrade_values();
  if ($fromto[0] != $fromto[1]) {
    echo "This forum is currently Cruciforum $fromto[0] and needs to be upgraded to $fromto[1].<br>";
    echo 'You need to run the <a href="cruciforum.php?action=upgrade">upgrade process</a>.';
    die();
  }
}

function get_upgrade_values() {
  // open list.tmpl and check its generator tag
  global $VERSION;
  $listtmpl = file_get_contents("list.tmpl");
  $lines = explode("\n", $listtmpl);
  $generated_by = "1.1";
  foreach ($lines as $line) {
    $isgen = preg_match(
      '/<meta name="generator" value="Cruciforum ([0-9.]+)">/',
      $line,
      $matches);
    if ($isgen) {
      $generated_by = $matches[1];
    }
  }
  return array($generated_by, $VERSION);
}

function upgrade() {
  $fromto = get_upgrade_values();
  $from = floatval($fromto[0]);
  echo "<h1>Upgrading Cruciforum</h1>\n";
  // notice that we fall through from each case
  switch(true) {
    case $from < 1.1: upgrade10to11();
    case $from < 1.2: upgrade11to12();
    case $from < 1.21: upgrade12to121();
  }
  write_out_template_files();
  echo "Your forum is now upgraded to Cruciforum $fromto[1]. ";
  echo '<a href="index.html">Knock yourself out!</a>';
  die();
}

function upgrade10to11() {
  echo "<h2>Upgrade from 1.0 to 1.1</h2>\n";
  // empty upgrade!
  echo "<p>Done.</p>";
}

function upgrade11to12() {
  echo "<h2>Upgrade from 1.1 to 1.2</h2>\n";
  
  $allfiles = get_all_html_filenames();
  
  echo "<h3>Add generator tag to files</h3>";
  echo "<p>";
  foreach ($allfiles as $file) {
    $data = file_get_contents($file);
    $data = str_replace(
      "<head>\n", 
      "<head>\n<meta name=\"generator\" content=\"Cruciforum 1.2\">\n",
      $data);
    file_put_contents($file, $data);
    echo $file . " ";
  }
  echo "</p>";
  
  echo "<p>Done.</p>";
}

function upgrade12to121() {
  echo "<h2>Upgrade from 1.2 to 1.21</h2>\n";
  
  $allfiles = get_all_html_filenames();
  
  echo "<ul>\n";
  echo "<li>Add content type</li>\n";
  echo "<li>Make individual posts hyperlinkable</li>\n";
  echo "<li>Add script type</li>\n";
  echo "<li>Upgrade generator tag</li>\n";
  echo "<li>Fix ampersand and alt attribute in gravatar URL</li>\n";
  echo "<li>Fix ampersand in email URL</li>\n";
  echo "<li>Fix ampersand in search URL</li>\n";
  echo "</ul>\n";
  echo "<p>";
  foreach ($allfiles as $file) {
    $data = file_get_contents($file);
    // add content type
    $data = str_replace(
      "<head>\n",
      "<head>\n<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\">\n",
      $data);
    // make individual posts hyperlinkable
    $data = preg_replace(
      '/<p>When: ([^<]+)<\/p>/',
      '<p>When: <a href="#d$1" name="d$1">$1</a></p>',
      $data);
    // add script type
    $data = preg_replace(
      '/<script src=/',
      '<script type="text/javascript" src=',
      $data);
    // upgrade generator tag
    $data = str_replace(
      "<meta name=\"generator\" content=\"Cruciforum 1.2\">\n",
      "<meta name=\"generator\" content=\"Cruciforum 1.21\">\n",
      $data);
    // Fix ampersand and alt attribute in gravatar URL
    $data = str_replace(
      '&size=40"></p>',
      '&amp;size=40" alt=""></p>',
      $data);
    // Fix ampersand in email URL
    $data = str_replace(
      'Email: <a href="../../cruciforum.php?action=email&email=',
      'Email: <a href="../../cruciforum.php?action=email&amp;email=',
      $data);
    // Fix ampersand in search URL
    $data = str_replace(
      '<a href="../../cruciforum.php?action=search&user=',
      '<a href="../../cruciforum.php?action=search&amp;user=',
      $data);
    
    file_put_contents($file, $data);
    echo $file . " ";
  }
  echo "</p>";
  
  echo "<p>Done.</p>";
}

function get_all_html_filenames() {
  return array_merge(glob("*.html"), glob("*/*/*.html"));
}

function badcall() {
  echo "Bad call";
  die();
}

function check_install() {
  if (file_exists("list.tmpl")) {
    badcall();
  } else {
    ask_for_forum_name();
  }
}

function ask_for_forum_name() {
  global $extras, $files;
  echo $extras["installation_header"];
  echo $extras["ask_for_forum_name"];
}

function install() {
  global $extras, $files;
  $FORUMNAME = htmlentities(stripslashes($_POST["forumname"]));
  echo $extras["installation_header"];
  // confirm that we can write files in this folder
  echo "<p>Checking that I can write files in this folder... ";
  $ret = @touch("index.html");
  if (!$ret) failed_install_writing();
  echo "done.</p>";
  write_out_template_files();
  // Create index.html
  write_from_template("list.tmpl", "index.html", Array("FORUMNAME"=>$FORUMNAME, "PREVPAGE"=>"index.html"));
  
  echo "<p>Writing forum name... ";
  file_put_contents("forumname", $FORUMNAME);
  echo "done.</p>";
  echo '<p>Cruciform is now installed! Please <a href="index.html">go to your new forum</a>.</p>';
}

function write_out_template_files() {
  global $files;
  echo "<p>Writing template files... ";
  foreach ($files as $fname => $text) {
    if (strpos($fname,"/") !== FALSE) {
      // name contains a folder
      @createfolder(dirname($fname));
    }
    echo "$fname ";
    if ($fname == "new.html") {
      $text = str_replace("{{FORUMNAME}}", $FORUMNAME, $text);
    }
    $ret = @file_put_contents($fname, $text);
    if ($ret === FALSE) failed_install_template($fname);
  }
  echo "done.</p>";
}

function write_from_template($tpl, $out, $vars) {
  $data = file_get_contents($tpl);
  $data = fill_template($data, $vars);
  createfolder(dirname($out));
  file_put_contents($out,$data);
}

function fill_template($data, $vars) {
  foreach ($vars as $k => $v) {
    $data = str_replace("{{".$k."}}", $v, $data);
  }
  return $data;
}

function failed_install_writing() {
  echo '<span class="fail">FAIL</span></p>';
  $curdir = getcwd();
  if (stristr($_SERVER['SERVER_SOFTWARE'], 'apache')) {
    $soft = "Apache, which is likely to be called www-data, ";
  } elseif (stristr($_SERVER['SERVER_SOFTWARE'], 'IIS')) {
    $soft = "IIS, which is likely to be called IUSR_".php_uname("n").", ";
  } else {
    $soft = "";
  }
  $uname = php_uname("s");
  if (strtoupper(substr($uname, 0, 3)) === 'WIN') {
    $os = "Windows";
  } else {
    $os = "a Unix of some description";
  }
  echo <<<__EOF
<p>Installation failed. I do not have permission to write
files in this folder.</p>
<p>This machine appears to be using $os. You should give write
permissions to this folder ($curdir) to the user account that runs $soft
and then refresh this page.</p>
__EOF;
  die();
}

function failed_install_template($fname) {
  echo '<span class="fail">FAIL</span></p>';
  echo <<<__EOF
<p>Installation failed. Writing out the template file "$fname" failed.</p>
__EOF;
  die();
}

function search() {
  $parts = explode("cruciforum.php",$_SERVER["SCRIPT_NAME"]);
  $url = "http://" . $_SERVER["HTTP_HOST"] . $parts[0];
  $user = $_GET["user"];
  $srch = "http://www.google.com/search?q=inurl:$url+%22Author: $user%22";
  header("Location: $srch");
}

function email() {
  echo "email function currently disabled";
  die();
  echo "email to ";
  global $FROMTR, $TOTR;
  $decemail = strtr($_GET["email"], $TOTR, $FROMTR);
  echo $decemail;
  die();
}

function newthread() {
  // load passed data
  $textile = new Textile;
  $text = $textile->TextileRestricted(stripslashes($_POST["text"]),1);
  $name = trim(htmlentities(stripslashes($_POST["name"])));
  if ($name == "") $name = "anonymous";
  $subject = htmlentities(stripslashes($_POST["threadsubject"]));
  if ($subject == "") $subject = "(post by $name)";
  $website = trim(htmlentities(stripslashes($_POST["website"])));
  if ($website != "") {
    // prefix http if required
    if (strpos($website,"http") === FALSE || strpos($website,"http") != 0) {
      $website = "http://" . $website;
    }
    $website = "<a href=\"$website\">&rarr;</a>";
  }
  $email = trim(htmlentities(stripslashes($_POST["email"])));
  global $FORUMNAME;
  if ($email != "") {
    global $FROMTR, $TOTR;
    $encemail = strtr($email, $FROMTR, $TOTR);
    $emailhref = "<a href=\"../../cruciforum.php?action=email&amp;email=$encemail\">&rarr;</a>";
  } else {
    $emailhref = "";
  }
  if (trim($text) == "") {
    echo "You cannot make a completely empty post! ";
    echo 'Please <a href="javascript:history.go(-1)">try again</a>.';
    die();
  }
  
  // Check for spam
  global $AKISMET_API_KEY;
  if ($AKISMET_API_KEY != "REPLACE THIS WITH YOUR KEY") {
    $comment = array(
      'author'    => $name,
      'email'     => $email,
      'website'   => $website,
      'body'      => $text
    );
 
    $parts = explode("cruciforum.php",$_SERVER["SCRIPT_NAME"]);
    $url = "http://" . $_SERVER["HTTP_HOST"] . $parts[0];
    $akismet = new Akismet($url, $AKISMET_API_KEY, 
      $comment);
 
    if(!$akismet->errorsExist()) {
      if($akismet->isSpam()) {
        echo "Your post has been categorised as possibly spam. ";
        echo "This is an automatic process, so it might be wrong. ";
        echo "You may want to consider removing some links or rewording. ";
        echo "Sorry! ";
        echo 'You can <a href="javascript:history.go(-1)">try editing it now</a>.';
        die();
      }
    }  
  }
  
  // get the lock
  $lockfile = fopen('editing.lock','w');
  flock($lockfile,LOCK_EX);
  // find highest post number and add 1
  $next_post_number = getNextPostNumber();
  $long_next_post_number = sprintf('%09d',$next_post_number);
  // create dt/dl for tN.html
  global $extras;
  $dtdl = fill_template($extras["thread_page_post"], Array(
    "TEXT" => $text,
    "NAME" => $name,
    "EMAIL" => $emailhref,
    "WEBSITE" => $website,
    "EMAILMD5" => md5($email),
    "DATE" => date('d/m/y H.i')
  ));
  // load thread.tmpl, write out tN.html
  write_from_template("thread.tmpl", makeFilename($next_post_number,"t"), Array(
    "THREADTITLE" => $subject,
    "FORUMNAME" => $FORUMNAME,
    "THREADID" => $long_next_post_number,
    "FIRSTPOST" => $dtdl
  ));
  // load tpost.tmpl, write out tpostN.html
  write_from_template("tpost.tmpl", makeFilename($next_post_number,"tpost"), Array(
    "THREADTITLE" => $subject,
    "FORUMNAME" => $FORUMNAME,
    "THREADID" => $long_next_post_number
  ));
  // create LI for index.html
  $li = fill_template($extras["index_page_link"], Array(
    "THREADTITLE" => $subject,
    "NAME" => $name,
    "THREADFILE" => makeFilename($next_post_number,"t"),
    "DATE" => date("jS M y")
  ));
  // load index.html
  $indexdata = file_get_contents("index.html");
  // does index.html have too many threads in?
  $threadcount = substr_count($indexdata, '<li class="threadlink">');
  global $THREADS_PER_LIST_PAGE;
  if ($threadcount >= intval($THREADS_PER_LIST_PAGE * 1.5)) {
    // find highest list number and add 1
    $highest = 0;
    foreach (glob('l[0-9]*.html') as $fn) {
      # strip off the number at the beginning
      if (preg_match('/l([0-9]+)\.html/', $fn, $matches)) {
        $num = intval($matches[1]);
        if ($num > $highest) $highest = $num;
      }
    }
    $newlistnum = $highest + 1;
    // load list.tmpl
    $tmpldata = file_get_contents("list.tmpl");
    if ($newlistnum == 1) { 
      $backdest = "index.html";
    } else { 
      $backdest = "l".$highest.".html";
    }
    $tmpldata = fill_template($tmpldata, Array(
      "FORUMNAME" => $FORUMNAME,
      "PREVPAGE" => $backdest
    ));
    
    $indexdata = preg_replace(
      '/(id="prev" href=")[^"]+(">previous posts)/',
      '${1}l' . $newlistnum . '.html$2', 
      $indexdata
    );
    // extract all <li>s from index.html
    preg_match_all('/<li class=.threadlink.>.*?<\/li>/s', $indexdata, $matches); // use . instead of " or it doesn't work
    $new_page_parts = array_slice($matches[0], -$THREADS_PER_LIST_PAGE);
    $index_page_parts = array_slice($matches[0], 0, -($THREADS_PER_LIST_PAGE));

    $new_page_lis = "";
    $index_page_lis = "";
    foreach ($new_page_parts as $part) {
      $new_page_lis .= $part . "\n";
    }
    foreach ($index_page_parts as $part) {
      $index_page_lis .= $part . "\n";
    }
    // remove all lis from indexdata
    $indexdata = preg_replace('/<li class="threadlink">.*?<\/li>/s','',$indexdata);
    // add the index lis to indexdata
    $indexdata = str_replace("</ul>", $index_page_lis . "\n</ul>", $indexdata);
    file_put_contents("index.html", $indexdata);

    $tmpldata = str_replace("</ul>", $new_page_lis . "\n</ul>", $tmpldata);
    file_put_contents("l" . $newlistnum . ".html", $tmpldata);
    
    // put those threads into lN.html
  }
  // add LI to index.html
  $indexdata = str_replace('<ul id="threads">', '<ul id="threads">' . "\n" . $li, $indexdata);
  // write out index.html
  file_put_contents("index.html", $indexdata);
  // release the lock
  flock($lockfile,LOCK_UN);
  // redirect to tN.html
  header("Location: " . makeFilename($next_post_number,"t") . "?replies=0");
    die();
}

function getNextPostNumber() {
  // does a binary search to find the highest filename
  $max = 1;
  while (file_exists(makeFilename($max,"t"))) {
    $max = $max * 2;
  }
  $min = intval($max / 2);
  while ($max - $min > 1) {
    $guess = intval(($min + $max) / 2);
    if (file_exists(makeFilename($guess,"t"))) {
      $min = $guess;
    } else {
      $max = $guess;
    }
  }
  return $max;
}

function makeFilename($n, $prefix) {
  // make a 000/056/t123456789.html filename from 56789
  $n2 = sprintf('%09d',$n);
  return substr($n2,0,3) . "/" . substr($n2,3,3) . "/" . $prefix . $n2 . ".html";
}

function newpost() {
  // load passed data
  $threadid = $_POST["thread"];
  if (!is_numeric($threadid)) badcall();
  $textile = new Textile;
  $text = $textile->TextileRestricted(stripslashes($_POST["text"]),1);
  $name = trim(htmlentities(stripslashes($_POST["name"])));
  if ($name == "") $name = "anonymous";
  $website = trim(htmlentities(stripslashes($_POST["website"])));
  if ($website != "") {
    // prefix http if required
    if (strpos($website,"http") === FALSE || strpos($website,"http") != 0) {
      $website = "http://" . $website;
    }
    $website = "<a href=\"$website\">&rarr;</a>";
  }
  $email = trim(htmlentities(stripslashes($_POST["email"])));
  if ($email != "") {
    global $FROMTR, $TOTR;
    $encemail = strtr($email, $FROMTR, $TOTR);
    $emailhref = "<a href=\"../../cruciforum.php?action=email&amp;email=$encemail\">&rarr;</a>";
  } else {
    $emailhref = "";
  }
  
  // Check for spam
  global $AKISMET_API_KEY;
  if ($AKISMET_API_KEY != "REPLACE THIS WITH YOUR KEY") {
    $comment = array(
      'author'    => $name,
      'email'     => $email,
      'website'   => $website,
      'body'      => $text
    );
 
    $parts = explode("cruciforum.php",$_SERVER["SCRIPT_NAME"]);
    $url = "http://" . $_SERVER["HTTP_HOST"] . $parts[0];
    $akismet = new Akismet('http://www.yourdomain.com/', $AKISMET_API_KEY, 
      $comment);
 
    if(!$akismet->errorsExist()) {
      if($akismet->isSpam()) {
        echo "Your post has been categorised as possibly spam. ";
        echo "This is an automatic process, so it might be wrong. ";
        echo "You may want to consider removing some links or rewording. ";
        echo "Sorry! ";
        echo 'You can <a href="javascript:history.go(-1)">try editing it now</a>.';
        die();
      }
    }  
  }
  

  // get the lock
  $lockfile = fopen('editing.lock','w');
  flock($lockfile,LOCK_EX);
  // load tN.html
  $fname = makeFilename($threadid,"t");
  $data = file_get_contents($fname);
  // create dt/dd of post
  global $extras;
  $postdatevalue = date('d/m/y H.i');
  $dtdl = fill_template($extras["thread_page_post"], Array(
    "TEXT" => $text,
    "NAME" => $name,
    "EMAIL" => $emailhref,
    "WEBSITE" => $website,
    "EMAILMD5" => md5($email),
    "DATE" => $postdatevalue
  ));
  // write dt/dd into tN.html
  $data = str_replace('</dl>', $dtdl . "\n</dl>", $data);
  file_put_contents($fname, $data);
  // loop
    // load index.html, l1.html, l2.html, ...
    // look for this thread link
    // update number of replies in url
    // write out file
    $replycount = 0;
    $ret = increment_reply_count("index.html", $fname);
    if (is_numeric($ret)) $replycount = $ret;
    if ($ret == "notfound") {
      $filec = 1;
      while ($ret != "nosuchfile") {
        $ret = increment_reply_count("l" . $filec . ".html", $fname);
        if (is_numeric($ret)) {
          $replycount = $ret;
          break;
        }
      }
    }
  // release the lock
  flock($lockfile,LOCK_UN);
  // redirect to tN.html
  header("Location: " . makeFilename($threadid,"t") . "?replies=" . $replycount . "#d" . $postdatevalue);
  die();
}

function increment_reply_count($indexfile, $fname) {
  if (!file_exists($indexfile)) return "nosuchfile";
  $data = file_get_contents($indexfile);
  if (strpos($data, $fname) === FALSE) {
    return "notfound";
  }
  $re = '/' . str_replace("/","\\/",$fname) . '\?replies=([0-9]+)"/';
  $v = preg_match($re, $data, $matches);
  $replies = intval($matches[1]);
  $replies += 1;
  $data = str_replace($matches[0], $fname . "?replies=" . $replies . '"', $data);
  file_put_contents($indexfile, $data);
  return $replies;
}

function createfolder( $folder ) {
  $folder = explode( "/" , $folder );
  $mkfolder = '';
  for(  $i=0 ; isset( $folder[$i] ) ; $i++ ) {
    $mkfolder .= $folder[$i];
    if( !is_dir( $mkfolder ) )
    mkdir( "$mkfolder" ,  0777);
    $mkfolder .= '/';
  }
}


/**
 * Example: get XHTML from a given Textile-markup string ($string)
 *
 *        $textile = new Textile;
 *        echo $textile->TextileThis($string);
 *
 */

/*
$Id: classTextile.php 216 2006-10-17 22:31:53Z zem $
$LastChangedRevision: 216 $
*/

/*

_____________
T E X T I L E

A Humane Web Text Generator

Version 2.0

Copyright (c) 2003-2004, Dean Allen <dean@textism.com>
All rights reserved.

Thanks to Carlo Zottmann <carlo@g-blog.net> for refactoring
Textile's procedural code into a class framework

Additions and fixes Copyright (c) 2006 Alex Shiels http://thresholdstate.com/

_____________
L I C E N S E

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name Textile nor the names of its contributors may be used to
  endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

_________
U S A G E

Block modifier syntax:

    Header: h(1-6).
    Paragraphs beginning with 'hn. ' (where n is 1-6) are wrapped in header tags.
    Example: h1. Header... -> <h1>Header...</h1>

    Paragraph: p. (also applied by default)
    Example: p. Text -> <p>Text</p>

    Blockquote: bq.
    Example: bq. Block quotation... -> <blockquote>Block quotation...</blockquote>

    Blockquote with citation: bq.:http://citation.url
    Example: bq.:http://textism.com/ Text...
    ->  <blockquote cite="http://textism.com">Text...</blockquote>

    Footnote: fn(1-100).
    Example: fn1. Footnote... -> <p id="fn1">Footnote...</p>

    Numeric list: #, ##
    Consecutive paragraphs beginning with # are wrapped in ordered list tags.
    Example: <ol><li>ordered list</li></ol>

    Bulleted list: *, **
    Consecutive paragraphs beginning with * are wrapped in unordered list tags.
    Example: <ul><li>unordered list</li></ul>

Phrase modifier syntax:

           _emphasis_   ->   <em>emphasis</em>
           __italic__   ->   <i>italic</i>
             *strong*   ->   <strong>strong</strong>
             **bold**   ->   <b>bold</b>
         ??citation??   ->   <cite>citation</cite>
       -deleted text-   ->   <del>deleted</del>
      +inserted text+   ->   <ins>inserted</ins>
        ^superscript^   ->   <sup>superscript</sup>
          ~subscript~   ->   <sub>subscript</sub>
               @code@   ->   <code>computer code</code>
          %(bob)span%   ->   <span class="bob">span</span>

        ==notextile==   ->   leave text alone (do not format)

       "linktext":url   ->   <a href="url">linktext</a>
 "linktext(title)":url  ->   <a href="url" title="title">linktext</a>

           !imageurl!   ->   <img src="imageurl" />
  !imageurl(alt text)!  ->   <img src="imageurl" alt="alt text" />
    !imageurl!:linkurl  ->   <a href="linkurl"><img src="imageurl" /></a>

ABC(Always Be Closing)  ->   <acronym title="Always Be Closing">ABC</acronym>


Table syntax:

    Simple tables:

        |a|simple|table|row|
        |And|Another|table|row|

        |_. A|_. table|_. header|_.row|
        |A|simple|table|row|

    Tables with attributes:

        table{border:1px solid black}.
        {background:#ddd;color:red}. |{}| | | |


Applying Attributes:

    Most anywhere Textile code is used, attributes such as arbitrary css style,
    css classes, and ids can be applied. The syntax is fairly consistent.

    The following characters quickly alter the alignment of block elements:

        <  ->  left align    ex. p<. left-aligned para
        >  ->  right align       h3>. right-aligned header 3
        =  ->  centred           h4=. centred header 4
        <> ->  justified         p<>. justified paragraph

    These will change vertical alignment in table cells:

        ^  ->  top         ex. |^. top-aligned table cell|
        -  ->  middle          |-. middle aligned|
        ~  ->  bottom          |~. bottom aligned cell|

    Plain (parentheses) inserted between block syntax and the closing dot-space
    indicate classes and ids:

        p(hector). paragraph -> <p class="hector">paragraph</p>

        p(#fluid). paragraph -> <p id="fluid">paragraph</p>

        (classes and ids can be combined)
        p(hector#fluid). paragraph -> <p class="hector" id="fluid">paragraph</p>

    Curly {brackets} insert arbitrary css style

        p{line-height:18px}. paragraph -> <p style="line-height:18px">paragraph</p>

        h3{color:red}. header 3 -> <h3 style="color:red">header 3</h3>

    Square [brackets] insert language attributes

        p[no]. paragraph -> <p lang="no">paragraph</p>

        %[fr]phrase% -> <span lang="fr">phrase</span>

    Usually Textile block element syntax requires a dot and space before the block
    begins, but since lists don't, they can be styled just using braces

        #{color:blue} one  ->  <ol style="color:blue">
        # big                   <li>one</li>
        # list                  <li>big</li>
                                <li>list</li>
                               </ol>

    Using the span tag to style a phrase

        It goes like this, %{color:red}the fourth the fifth%
              -> It goes like this, <span style="color:red">the fourth the fifth</span>

*/


class Textile
{
    var $hlgn;
    var $vlgn;
    var $clas;
    var $lnge;
    var $styl;
    var $cspn;
    var $rspn;
    var $a;
    var $s;
    var $c;
    var $pnct;
    var $rel;
    var $fn;
    
    var $shelf = array();
    var $restricted = false;
    var $noimage = false;
    var $lite = false;
    var $url_schemes = array();
    var $glyph = array();
    var $hu = '';
    
    var $ver = '2.0.0';
    var $rev = '$Rev: 216 $';

// -------------------------------------------------------------
    function Textile()
    {
        $this->hlgn = "(?:\<(?!>)|(?<!<)\>|\<\>|\=|[()]+(?! ))";
        $this->vlgn = "[\-^~]";
        $this->clas = "(?:\([^)]+\))";
        $this->lnge = "(?:\[[^]]+\])";
        $this->styl = "(?:\{[^}]+\})";
        $this->cspn = "(?:\\\\\d+)";
        $this->rspn = "(?:\/\d+)";
        $this->a = "(?:{$this->hlgn}|{$this->vlgn})*";
        $this->s = "(?:{$this->cspn}|{$this->rspn})*";
        $this->c = "(?:{$this->clas}|{$this->styl}|{$this->lnge}|{$this->hlgn})*";

        $this->pnct = '[\!"#\$%&\'()\*\+,\-\./:;<=>\?@\[\\\]\^_`{\|}\~]';
        $this->urlch = '[\w"$\-_.+!*\'(),";\/?:@=&%#{}|\\^~\[\]`]';

        $this->url_schemes = array('http','https','ftp','mailto');

        $this->btag = array('bq', 'bc', 'notextile', 'pre', 'h[1-6]', 'fn\d+', 'p');

        $this->glyph = array(
           'quote_single_open'  => txt_quote_single_open,
           'quote_single_close' => txt_quote_single_close,
           'quote_double_open'  => txt_quote_double_open,
           'quote_double_close' => txt_quote_double_close,
           'apostrophe'         => txt_apostrophe,
           'prime'              => txt_prime,
           'prime_double'       => txt_prime_double,
           'ellipsis'           => txt_ellipsis,
           'emdash'             => txt_emdash,
           'endash'             => txt_endash,
           'dimension'          => txt_dimension,
           'trademark'          => txt_trademark,
           'registered'         => txt_registered,
           'copyright'          => txt_copyright,
        );

        if (defined('hu'))
            $this->hu = hu;

    }

// -------------------------------------------------------------
    function TextileThis($text, $lite='', $encode='', $noimage='', $strict='', $rel='')
    {
        if ($rel)
           $this->rel = ' rel="'.$rel.'" ';
        $this->lite = $lite;
        $this->noimage = $noimage;

        if ($encode) {
         $text = $this->incomingEntities($text);
            $text = str_replace("x%x%", "&#38;", $text);
            return $text;
        } else {

            if(!$strict) {
                $text = $this->cleanWhiteSpace($text);
            }

            $text = $this->getRefs($text);

            if (!$lite) {
                $text = $this->block($text);
            }

            $text = $this->retrieve($text);

                // just to be tidy
            $text = str_replace("<br />", "<br />\n", $text);

            return $text;
        }
    }

// -------------------------------------------------------------
    function TextileRestricted($text, $lite=1, $noimage=1, $rel='nofollow')
    {
        $this->restricted = true;
        $this->lite = $lite;
        $this->noimage = $noimage;
        if ($rel)
           $this->rel = ' rel="'.$rel.'" ';

            // escape any raw html
            $text = $this->encode_html($text, 0);

            $text = $this->cleanWhiteSpace($text);
            $text = $this->getRefs($text);

            if ($lite) {
                $text = $this->blockLite($text);
            }
            else {
                $text = $this->block($text);
            }

            $text = $this->retrieve($text);

                // just to be tidy
            $text = str_replace("<br />", "<br />\n", $text);

            return $text;
    }

// -------------------------------------------------------------
    function pba($in, $element = "") // "parse block attributes"
    {
        $style = '';
        $class = '';
        $lang = '';
        $colspan = '';
        $rowspan = '';
        $id = '';
        $atts = '';

        if (!empty($in)) {
            $matched = $in;
            if ($element == 'td') {
                if (preg_match("/\\\\(\d+)/", $matched, $csp)) $colspan = $csp[1];
                if (preg_match("/\/(\d+)/", $matched, $rsp)) $rowspan = $rsp[1];
            }

            if ($element == 'td' or $element == 'tr') {
                if (preg_match("/($this->vlgn)/", $matched, $vert))
                    $style[] = "vertical-align:" . $this->vAlign($vert[1]) . ";";
            }

            if (preg_match("/\{([^}]*)\}/", $matched, $sty)) {
                $style[] = rtrim($sty[1], ';') . ';';
                $matched = str_replace($sty[0], '', $matched);
            }

            if (preg_match("/\[([^]]+)\]/U", $matched, $lng)) {
                $lang = $lng[1];
                $matched = str_replace($lng[0], '', $matched);
            }

            if (preg_match("/\(([^()]+)\)/U", $matched, $cls)) {
                $class = $cls[1];
                $matched = str_replace($cls[0], '', $matched);
            }

            if (preg_match("/([(]+)/", $matched, $pl)) {
                $style[] = "padding-left:" . strlen($pl[1]) . "em;";
                $matched = str_replace($pl[0], '', $matched);
            }

            if (preg_match("/([)]+)/", $matched, $pr)) {
                // $this->dump($pr);
                $style[] = "padding-right:" . strlen($pr[1]) . "em;";
                $matched = str_replace($pr[0], '', $matched);
            }

            if (preg_match("/($this->hlgn)/", $matched, $horiz))
                $style[] = "text-align:" . $this->hAlign($horiz[1]) . ";";

            if (preg_match("/^(.*)#(.*)$/", $class, $ids)) {
                $id = $ids[2];
                $class = $ids[1];
            }

            if ($this->restricted)
                return ($lang)    ? ' lang="'    . $lang            .'"':'';

            return join('',array(
                ($style)   ? ' style="'   . join("", $style) .'"':'',
                ($class)   ? ' class="'   . $class           .'"':'',
                ($lang)    ? ' lang="'    . $lang            .'"':'',
                ($id)      ? ' id="'      . $id              .'"':'',
                ($colspan) ? ' colspan="' . $colspan         .'"':'',
                ($rowspan) ? ' rowspan="' . $rowspan         .'"':''
            ));
        }
        return '';
    }

// -------------------------------------------------------------
    function hasRawText($text)
    {
        // checks whether the text has text not already enclosed by a block tag
        $r = trim(preg_replace('@<(p|blockquote|div|form|table|ul|ol|pre|h\d)[^>]*?>.*</\1>@s', '', trim($text)));
        $r = trim(preg_replace('@<(hr|br)[^>]*?/>@', '', $r));
        return '' != $r;
    }

// -------------------------------------------------------------
    function table($text)
    {
        $text = $text . "\n\n";
        return preg_replace_callback("/^(?:table(_?{$this->s}{$this->a}{$this->c})\. ?\n)?^({$this->a}{$this->c}\.? ?\|.*\|)\n\n/smU",
           array(&$this, "fTable"), $text);
    }

// -------------------------------------------------------------
    function fTable($matches)
    {
        $tatts = $this->pba($matches[1], 'table');

        foreach(preg_split("/\|$/m", $matches[2], -1, PREG_SPLIT_NO_EMPTY) as $row) {
            if (preg_match("/^($this->a$this->c\. )(.*)/m", ltrim($row), $rmtch)) {
                $ratts = $this->pba($rmtch[1], 'tr');
                $row = $rmtch[2];
            } else $ratts = '';

                $cells = array();
            foreach(explode("|", $row) as $cell) {
                $ctyp = "d";
                if (preg_match("/^_/", $cell)) $ctyp = "h";
                if (preg_match("/^(_?$this->s$this->a$this->c\. )(.*)/", $cell, $cmtch)) {
                    $catts = $this->pba($cmtch[1], 'td');
                    $cell = $cmtch[2];
                } else $catts = '';

                $cell = $this->graf($this->span($cell));

                if (trim($cell) != '')
                    $cells[] = "\t\t\t<t$ctyp$catts>$cell</t$ctyp>";
            }
            $rows[] = "\t\t<tr$ratts>\n" . join("\n", $cells) . ($cells ? "\n" : "") . "\t\t</tr>";
            unset($cells, $catts);
        }
        return "\t<table$tatts>\n" . join("\n", $rows) . "\n\t</table>\n\n";
    }

// -------------------------------------------------------------
    function lists($text)
    {
        return preg_replace_callback("/^([#*]+$this->c .*)$(?![^#*])/smU", array(&$this, "fList"), $text);
    }

// -------------------------------------------------------------
    function fList($m)
    {
        $text = explode("\n", $m[0]);
        foreach($text as $line) {
            $nextline = next($text);
            if (preg_match("/^([#*]+)($this->a$this->c) (.*)$/s", $line, $m)) {
                list(, $tl, $atts, $content) = $m;
                $nl = '';
                if (preg_match("/^([#*]+)\s.*/", $nextline, $nm))
                	$nl = $nm[1];
                if (!isset($lists[$tl])) {
                    $lists[$tl] = true;
                    $atts = $this->pba($atts);
                    $line = "\t<" . $this->lT($tl) . "l$atts>\n\t\t<li>" . $this->graf($content);
                } else {
                    $line = "\t\t<li>" . $this->graf($content);
                }

                if(strlen($nl) <= strlen($tl)) $line .= "</li>";
                foreach(array_reverse($lists) as $k => $v) {
                    if(strlen($k) > strlen($nl)) {
                        $line .= "\n\t</" . $this->lT($k) . "l>";
                        if(strlen($k) > 1)
                            $line .= "</li>";
                        unset($lists[$k]);
                    }
                }
            }
            $out[] = $line;
        }
        return join("\n", $out);
    }

// -------------------------------------------------------------
    function lT($in)
    {
        return preg_match("/^#+/", $in) ? 'o' : 'u';
    }

// -------------------------------------------------------------
    function doPBr($in)
    {
        return preg_replace_callback('@<(p)([^>]*?)>(.*)(</\1>)@s', array(&$this, 'doBr'), $in);
    }

// -------------------------------------------------------------
    function doBr($m)
    {
        $content = preg_replace("@(.+)(?<!<br>|<br />)\n(?![#*\s|])@", '$1<br />', $m[3]);
        return '<'.$m[1].$m[2].'>'.$content.$m[4];
    }

// -------------------------------------------------------------
    function block($text)
    {
        $find = $this->btag;
        $tre = join('|', $find);

        $text = explode("\n\n", $text);

        $tag = 'p';
        $atts = $cite = $graf = $ext  = '';

        foreach($text as $line) {
            $anon = 0;
            if (preg_match("/^($tre)($this->a$this->c)\.(\.?)(?::(\S+))? (.*)$/s", $line, $m)) {
                // last block was extended, so close it
                if ($ext)
                    $out[count($out)-1] .= $c1;
                // new block
                list(,$tag,$atts,$ext,$cite,$graf) = $m;
                list($o1, $o2, $content, $c2, $c1) = $this->fBlock(array(0,$tag,$atts,$ext,$cite,$graf));

                // leave off c1 if this block is extended, we'll close it at the start of the next block
                if ($ext)
                    $line = $o1.$o2.$content.$c2;
                else
                    $line = $o1.$o2.$content.$c2.$c1;
            }
            else {
                // anonymous block
                $anon = 1;
                if ($ext or !preg_match('/^ /', $line)) {
                    list($o1, $o2, $content, $c2, $c1) = $this->fBlock(array(0,$tag,$atts,$ext,$cite,$line));
                    // skip $o1/$c1 because this is part of a continuing extended block
                    if ($tag == 'p' and !$this->hasRawText($content)) {
                        $line = $content;
                    }
                    else {
                        $line = $o2.$content.$c2;
                    }
                }
                else {
                   $line = $this->graf($line);
                }
            }

            $line = $this->doPBr($line);
            $line = preg_replace('/<br>/', '<br />', $line);

            if ($ext and $anon)
                $out[count($out)-1] .= "\n".$line;
            else
                $out[] = $line;

            if (!$ext) {
                $tag = 'p';
                $atts = '';
                $cite = '';
                $graf = '';
            }
        }
        if ($ext) $out[count($out)-1] .= $c1;
        return join("\n\n", $out);
    }



// -------------------------------------------------------------
    function fBlock($m)
    {
        // $this->dump($m);
        list(, $tag, $atts, $ext, $cite, $content) = $m;
        $atts = $this->pba($atts);

        $o1 = $o2 = $c2 = $c1 = '';

        if (preg_match("/fn(\d+)/", $tag, $fns)) {
            $tag = 'p';
            $fnid = empty($this->fn[$fns[1]]) ? $fns[1] : $this->fn[$fns[1]];
            $atts .= ' id="fn' . $fnid . '"';
            if (strpos($atts, 'class=') === false)
                $atts .= ' class="footnote"';
            $content = '<sup>' . $fns[1] . '</sup> ' . $content;
        }

        if ($tag == "bq") {
            $cite = $this->checkRefs($cite);
            $cite = ($cite != '') ? ' cite="' . $cite . '"' : '';
            $o1 = "\t<blockquote$cite$atts>\n";
            $o2 = "\t\t<p$atts>";
            $c2 = "</p>";
            $c1 = "\n\t</blockquote>";
        }
        elseif ($tag == 'bc') {
            $o1 = "<pre$atts>";
            $o2 = "<code$atts>";
            $c2 = "</code>";
            $c1 = "</pre>";
            $content = $this->shelve($this->encode_html(rtrim($content, "\n")."\n"));
        }
        elseif ($tag == 'notextile') {
            $content = $this->shelve($content);
            $o1 = $o2 = '';
            $c1 = $c2 = '';
        }
        elseif ($tag == 'pre') {
            $content = $this->shelve($this->encode_html(rtrim($content, "\n")."\n"));
            $o1 = "<pre$atts>";
            $o2 = $c2 = '';
            $c1 = "</pre>";
        }
        else {
            $o2 = "\t<$tag$atts>";
            $c2 = "</$tag>";
          }

        $content = $this->graf($content);

        return array($o1, $o2, $content, $c2, $c1);
    }

// -------------------------------------------------------------
    function graf($text)
    {
        // handle normal paragraph text
        if (!$this->lite) {
            $text = $this->noTextile($text);
            $text = $this->code($text);
        }

        $text = $this->links($text);
        if (!$this->noimage)
            $text = $this->image($text);

        if (!$this->lite) {
            $text = $this->lists($text);
            $text = $this->table($text);
        }

        $text = $this->span($text);
        $text = $this->footnoteRef($text);
        $text = $this->glyphs($text);
        return rtrim($text, "\n");
    }

// -------------------------------------------------------------
    function span($text)
    {
        $qtags = array('\*\*','\*','\?\?','-','__','_','%','\+','~','\^');
        $pnct = ".,\"'?!;:";

        foreach($qtags as $f) {
            $text = preg_replace_callback("/
                (?:^|(?<=[\s>$pnct])|([{[]))
                ($f)(?!$f)
                ({$this->c})
                (?::(\S+))?
                ([^\s$f]+|\S[^$f\n]*[^\s$f\n])
                ([$pnct]*)
                $f
                (?:$|([\]}])|(?=[[:punct:]]{1,2}|\s))
            /x", array(&$this, "fSpan"), $text);
        }
        return $text;
    }

// -------------------------------------------------------------
    function fSpan($m)
    {
        $qtags = array(
            '*'  => 'strong',
            '**' => 'b',
            '??' => 'cite',
            '_'  => 'em',
            '__' => 'i',
            '-'  => 'del',
            '%'  => 'span',
            '+'  => 'ins',
            '~'  => 'sub',
            '^'  => 'sup',
        );

        list(,, $tag, $atts, $cite, $content, $end) = $m;
        $tag = $qtags[$tag];
        $atts = $this->pba($atts);
        $atts .= ($cite != '') ? 'cite="' . $cite . '"' : '';

        $out = "<$tag$atts>$content$end</$tag>";

//      $this->dump($out);

        return $out;

    }

// -------------------------------------------------------------
    function links($text)
    {
        return preg_replace_callback('/
            (?:^|(?<=[\s>.$pnct\(])|([{[])) # $pre
            "                            # start
            (' . $this->c . ')           # $atts
            ([^"]+)                      # $text
            \s?
            (?:\(([^)]+)\)(?="))?        # $title
            ":
            ('.$this->urlch.'+)          # $url
            (\/)?                        # $slash
            ([^\w\/;]*)                  # $post
            (?:([\]}])|(?=\s|$|\)))
        /Ux', array(&$this, "fLink"), $text);
    }

// -------------------------------------------------------------
    function fLink($m)
    {
        list(, $pre, $atts, $text, $title, $url, $slash, $post) = $m;

        $url = $this->checkRefs($url);

        $atts = $this->pba($atts);
        $atts .= ($title != '') ? ' title="' . $this->encode_html($title) . '"' : '';

        if (!$this->noimage)
            $text = $this->image($text);

        $text = $this->span($text);
        $text = $this->glyphs($text);

        $url = $this->relURL($url);

        $out = '<a href="' . $this->encode_html($url . $slash) . '"' . $atts . $this->rel . '>' . $text . '</a>' . $post;

        // $this->dump($out);
        return $this->shelve($out);

    }

// -------------------------------------------------------------
    function getRefs($text)
    {
        return preg_replace_callback("/(?<=^|\s)\[(.+)\]((?:http:\/\/|\/)\S+)(?=\s|$)/U",
            array(&$this, "refs"), $text);
    }

// -------------------------------------------------------------
    function refs($m)
    {
        list(, $flag, $url) = $m;
        $this->urlrefs[$flag] = $url;
        return '';
    }

// -------------------------------------------------------------
    function checkRefs($text)
    {
        return (isset($this->urlrefs[$text])) ? $this->urlrefs[$text] : $text;
    }

// -------------------------------------------------------------
    function relURL($url)
    {
        $parts = parse_url($url);
        if ((empty($parts['scheme']) or @$parts['scheme'] == 'http') and
             empty($parts['host']) and
             preg_match('/^\w/', @$parts['path']))
            $url = $this->hu.$url;
        if ($this->restricted and !empty($parts['scheme']) and
              !in_array($parts['scheme'], $this->url_schemes))
            return '#';
        return $url;
    }

// -------------------------------------------------------------
    function image($text)
    {
        return preg_replace_callback("/
            (?:[[{])?          # pre
            \!                 # opening !
            (\<|\=|\>)??       # optional alignment atts
            ($this->c)         # optional style,class atts
            (?:\. )?           # optional dot-space
            ([^\s(!]+)         # presume this is the src
            \s?                # optional space
            (?:\(([^\)]+)\))?  # optional title
            \!                 # closing
            (?::(\S+))?        # optional href
            (?:[\]}]|(?=\s|$)) # lookahead: space or end of string
        /Ux", array(&$this, "fImage"), $text);
    }

// -------------------------------------------------------------
    function fImage($m)
    {
        list(, $algn, $atts, $url) = $m;
        $atts  = $this->pba($atts);
        $atts .= ($algn != '')  ? ' align="' . $this->iAlign($algn) . '"' : '';
        $atts .= (isset($m[4])) ? ' title="' . $m[4] . '"' : '';
        $atts .= (isset($m[4])) ? ' alt="'   . $m[4] . '"' : ' alt=""';
        $size = @getimagesize($url);
        if ($size) $atts .= " $size[3]";

        $href = (isset($m[5])) ? $this->checkRefs($m[5]) : '';
        $url = $this->checkRefs($url);

        $url = $this->relURL($url);

        $out = array(
            ($href) ? '<a href="' . $href . '">' : '',
            '<img src="' . $url . '"' . $atts . ' />',
            ($href) ? '</a>' : ''
        );

        return join('',$out);
    }

// -------------------------------------------------------------
    function code($text)
    {
        $text = $this->doSpecial($text, '<code>', '</code>', 'fCode');
        $text = $this->doSpecial($text, '@', '@', 'fCode');
        $text = $this->doSpecial($text, '<pre>', '</pre>', 'fPre');
        return $text;
    }

// -------------------------------------------------------------
    function fCode($m)
    {
      @list(, $before, $text, $after) = $m;
      if ($this->restricted)
          // $text is already escaped
            return $before.$this->shelve('<code>'.$text.'</code>').$after;
      else
            return $before.$this->shelve('<code>'.$this->encode_html($text).'</code>').$after;
    }

// -------------------------------------------------------------
    function fPre($m)
    {
      @list(, $before, $text, $after) = $m;
      if ($this->restricted)
          // $text is already escaped
            return $before.'<pre>'.$this->shelve($text).'</pre>'.$after;
      else
            return $before.'<pre>'.$this->shelve($this->encode_html($text)).'</pre>'.$after;
    }
// -------------------------------------------------------------
    function shelve($val)
    {
        $i = uniqid(rand());
        $this->shelf[$i] = $val;
        return $i;
    }

// -------------------------------------------------------------
    function retrieve($text)
    {
        if (is_array($this->shelf))
            do {
                $old = $text;
                $text = strtr($text, $this->shelf);
             } while ($text != $old);

        return $text;
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function incomingEntities($text)
    {
        return preg_replace("/&(?![#a-z0-9]+;)/i", "x%x%", $text);
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function encodeEntities($text)
    {
        return (function_exists('mb_encode_numericentity'))
        ?    $this->encode_high($text)
        :    htmlentities($text, ENT_NOQUOTES, "utf-8");
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function fixEntities($text)
    {
        /*  de-entify any remaining angle brackets or ampersands */
        return str_replace(array("&gt;", "&lt;", "&amp;"),
            array(">", "<", "&"), $text);
    }

// -------------------------------------------------------------
    function cleanWhiteSpace($text)
    {
        $out = str_replace("\r\n", "\n", $text);
        $out = preg_replace("/\n{3,}/", "\n\n", $out);
        $out = preg_replace("/\n *\n/", "\n\n", $out);
        $out = preg_replace('/"$/', "\" ", $out);
        return $out;
    }

// -------------------------------------------------------------
    function doSpecial($text, $start, $end, $method='fSpecial')
    {
      return preg_replace_callback('/(^|\s|[[({>])'.preg_quote($start, '/').'(.*?)'.preg_quote($end, '/').'(\s|$|[\])}])?/ms',
            array(&$this, $method), $text);
    }

// -------------------------------------------------------------
    function fSpecial($m)
    {
        // A special block like notextile or code
      @list(, $before, $text, $after) = $m;
        return $before.$this->shelve($this->encode_html($text)).$after;
    }

// -------------------------------------------------------------
    function noTextile($text)
    {
         $text = $this->doSpecial($text, '<notextile>', '</notextile>', 'fTextile');
         return $this->doSpecial($text, '==', '==', 'fTextile');

    }

// -------------------------------------------------------------
    function fTextile($m)
    {
        @list(, $before, $notextile, $after) = $m;
        #$notextile = str_replace(array_keys($modifiers), array_values($modifiers), $notextile);
        return $before.$this->shelve($notextile).$after;
    }

// -------------------------------------------------------------
    function footnoteRef($text)
    {
        return preg_replace('/\b\[([0-9]+)\](\s)?/Ue',
            '$this->footnoteID(\'\1\',\'\2\')', $text);
    }

// -------------------------------------------------------------
    function footnoteID($id, $t)
    {
        if (empty($this->fn[$id]))
            $this->fn[$id] = uniqid(rand());
        $fnid = $this->fn[$id];
        return '<sup class="footnote"><a href="#fn'.$fnid.'">'.$id.'</a></sup>'.$t;
    }

// -------------------------------------------------------------
    function glyphs($text)
    {
        // fix: hackish
        $text = preg_replace('/"\z/', "\" ", $text);
        $pnc = '[[:punct:]]';

        $glyph_search = array(
            '/(\w)\'(\w)/',                                      // apostrophe's
            '/(\s)\'(\d+\w?)\b(?!\')/',                          // back in '88
            '/(\S)\'(?=\s|'.$pnc.'|<|$)/',                       //  single closing
            '/\'/',                                              //  single opening
            '/(\S)\"(?=\s|'.$pnc.'|<|$)/',                       //  double closing
            '/"/',                                               //  double opening
            '/\b([A-Z][A-Z0-9]{2,})\b(?:[(]([^)]*)[)])/',        //  3+ uppercase acronym
            '/\b([A-Z][A-Z\'\-]+[A-Z])(?=[\s.,\)>])/',           //  3+ uppercase
            '/\b( )?\.{3}/',                                     //  ellipsis
            '/(\s?)--(\s?)/',                                    //  em dash
            '/\s-(?:\s|$)/',                                     //  en dash
            '/(\d+)( ?)x( ?)(?=\d+)/',                           //  dimension sign
            '/\b ?[([]TM[])]/i',                                 //  trademark
            '/\b ?[([]R[])]/i',                                  //  registered
            '/\b ?[([]C[])]/i',                                  //  copyright
         );

        extract($this->glyph, EXTR_PREFIX_ALL, 'txt');

        $glyph_replace = array(
            '$1'.$txt_apostrophe.'$2',           // apostrophe's
            '$1'.$txt_apostrophe.'$2',           // back in '88
            '$1'.$txt_quote_single_close,        //  single closing
            $txt_quote_single_open,              //  single opening
            '$1'.$txt_quote_double_close,        //  double closing
            $txt_quote_double_open,              //  double opening
            '<acronym title="$2">$1</acronym>',  //  3+ uppercase acronym
            '<span class="caps">$1</span>',      //  3+ uppercase
            '$1'.$txt_ellipsis,                  //  ellipsis
            '$1'.$txt_emdash.'$2',               //  em dash
            ' '.$txt_endash.' ',                 //  en dash
            '$1$2'.$txt_dimension.'$3',          //  dimension sign
            $txt_trademark,                      //  trademark
            $txt_registered,                     //  registered
            $txt_copyright,                      //  copyright
         );

         $text = preg_split("/(<.*>)/U", $text, -1, PREG_SPLIT_DELIM_CAPTURE);
         foreach($text as $line) {
             if (!preg_match("/<.*>/", $line)) {
                 $line = preg_replace($glyph_search, $glyph_replace, $line);
             }
              $glyph_out[] = $line;
         }
         return join('', $glyph_out);
    }

// -------------------------------------------------------------
    function iAlign($in)
    {
        $vals = array(
            '<' => 'left',
            '=' => 'center',
            '>' => 'right');
        return (isset($vals[$in])) ? $vals[$in] : '';
    }

// -------------------------------------------------------------
    function hAlign($in)
    {
        $vals = array(
            '<'  => 'left',
            '='  => 'center',
            '>'  => 'right',
            '<>' => 'justify');
        return (isset($vals[$in])) ? $vals[$in] : '';
    }

// -------------------------------------------------------------
    function vAlign($in)
    {
        $vals = array(
            '^' => 'top',
            '-' => 'middle',
            '~' => 'bottom');
        return (isset($vals[$in])) ? $vals[$in] : '';
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function encode_high($text, $charset = "UTF-8")
    {
        return mb_encode_numericentity($text, $this->cmap(), $charset);
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function decode_high($text, $charset = "UTF-8")
    {
        return mb_decode_numericentity($text, $this->cmap(), $charset);
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function cmap()
    {
        $f = 0xffff;
        $cmap = array(
            0x0080, 0xffff, 0, $f);
        return $cmap;
    }

// -------------------------------------------------------------
    function encode_html($str, $quotes=1)
    {
        $a = array(
            '&' => '&#38;',
            '<' => '&#60;',
            '>' => '&#62;',
        );
        if ($quotes) $a = $a + array(
            "'" => '&#39;',
            '"' => '&#34;',
        );

        return strtr($str, $a);
    }

// -------------------------------------------------------------
    function textile_popup_help($name, $helpvar, $windowW, $windowH)
    {
        return ' <a target="_blank" href="http://www.textpattern.com/help/?item=' . $helpvar . '" onclick="window.open(this.href, \'popupwindow\', \'width=' . $windowW . ',height=' . $windowH . ',scrollbars,resizable\'); return false;">' . $name . '</a><br />';

        return $out;
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function txtgps($thing)
    {
        if (isset($_POST[$thing])) {
            if (get_magic_quotes_gpc()) {
                return stripslashes($_POST[$thing]);
            }
            else {
                return $_POST[$thing];
            }
        }
        else {
            return '';
        }
    }

// -------------------------------------------------------------
// NOTE: deprecated
    function dump()
    {
        foreach (func_get_args() as $a)
            echo "\n<pre>",(is_array($a)) ? print_r($a) : $a, "</pre>\n";
    }

// -------------------------------------------------------------

    function blockLite($text)
    {
        $this->btag = array('bq', 'p');
        return $this->block($text."\n\n");
    }


} // end class



/**
 * 01.26.2006 12:29:28est
 * 
 * Akismet PHP4 class
 * 
 * <b>Usage</b>
 * <code>
 *    $comment = array(
 *           'author'    => 'viagra-test-123',
 *           'email'     => 'test@example.com',
 *           'website'   => 'http://www.example.com/',
 *           'body'      => 'This is a test comment',
 *           'permalink' => 'http://yourdomain.com/yourblogpost.url',
 *        );
 *
 *    $akismet = new Akismet('http://www.yourdomain.com/', 'YOUR_WORDPRESS_API_KEY', $comment);
 *
 *    if($akismet->isError()) {
 *        echo"Couldn't connected to Akismet server!";
 *    } else {
 *        if($akismet->isSpam()) {
 *            echo"Spam detected";
 *        } else {
 *            echo"yay, no spam!";
 *        }
 *    }
 * </code>
 * 
 * @author Bret Kuhns {@link www.miphp.net}
 * @link http://www.miphp.net/blog/view/php4_akismet_class/
 * @version 0.3.3
 * @license http://www.opensource.org/licenses/mit-license.php MIT License
 */



// Error constants
define("AKISMET_SERVER_NOT_FOUND",	0);
define("AKISMET_RESPONSE_FAILED",	1);
define("AKISMET_INVALID_KEY",		2);



// Base class to assist in error handling between Akismet classes
class AkismetObject {
	var $errors = array();
	
	
	/**
	 * Add a new error to the errors array in the object
	 *
	 * @param	String	$name	A name (array key) for the error
	 * @param	String	$string	The error message
	 * @return void
	 */ 
	// Set an error in the object
	function setError($name, $message) {
		$this->errors[$name] = $message;
	}
	

	/**
	 * Return a specific error message from the errors array
	 *
	 * @param	String	$name	The name of the error you want
	 * @return mixed	Returns a String if the error exists, a false boolean if it does not exist
	 */
	function getError($name) {
		if($this->isError($name)) {
			return $this->errors[$name];
		} else {
			return false;
		}
	}
	
	
	/**
	 * Return all errors in the object
	 *
	 * @return String[]
	 */ 
	function getErrors() {
		return (array)$this->errors;
	}
	
	
	/**
	 * Check if a certain error exists
	 *
	 * @param	String	$name	The name of the error you want
	 * @return boolean
	 */ 
	function isError($name) {
		return isset($this->errors[$name]);
	}
	
	
	/**
	 * Check if any errors exist
	 *
	 * @return boolean
	 */
	function errorsExist() {
		return (count($this->errors) > 0);
	}
	
	
}





// Used by the Akismet class to communicate with the Akismet service
class AkismetHttpClient extends AkismetObject {
	var $akismetVersion = '1.1';
	var $con;
	var $host;
	var $port;
	var $apiKey;
	var $blogUrl;
	var $errors = array();
	
	
	// Constructor
	function AkismetHttpClient($host, $blogUrl, $apiKey, $port = 80) {
		$this->host = $host;
		$this->port = $port;
		$this->blogUrl = $blogUrl;
		$this->apiKey = $apiKey;
	}
	
	
	// Use the connection active in $con to get a response from the server and return that response
	function getResponse($request, $path, $type = "post", $responseLength = 1160) {
		$this->_connect();
		
		if($this->con && !$this->isError(AKISMET_SERVER_NOT_FOUND)) {
			$request  = 
					strToUpper($type)." /{$this->akismetVersion}/$path HTTP/1.1\r\n" .
					"Host: ".((!empty($this->apiKey)) ? $this->apiKey."." : null)."{$this->host}\r\n" .
					"Content-Type: application/x-www-form-urlencoded; charset=utf-8\r\n" .
					"Content-Length: ".strlen($request)."\r\n" .
					"User-Agent: Akismet PHP4 Class\r\n" .
					"\r\n" .
					$request
				;
			$response = "";

			@fwrite($this->con, $request);

			while(!feof($this->con)) {
				$response .= @fgets($this->con, $responseLength);
			}

			$response = explode("\r\n\r\n", $response, 2);
			return $response[1];
		} else {
			$this->setError(AKISMET_RESPONSE_FAILED, "The response could not be retrieved.");
		}
		
		$this->_disconnect();
	}
	
	
	// Connect to the Akismet server and store that connection in the instance variable $con
	function _connect() {
		if(!($this->con = @fsockopen($this->host, $this->port))) {
			$this->setError(AKISMET_SERVER_NOT_FOUND, "Could not connect to akismet server.");
		}
	}
	
	
	// Close the connection to the Akismet server
	function _disconnect() {
		@fclose($this->con);
	}
	
	
}





// The controlling class. This is the ONLY class the user should instantiate in
// order to use the Akismet service!
class Akismet extends AkismetObject {
	var $apiPort = 80;
	var $akismetServer = 'rest.akismet.com';
	var $akismetVersion = '1.1';
	var $http;
	
	var $ignore = array(
			'HTTP_COOKIE',
			'HTTP_X_FORWARDED_FOR',
			'HTTP_X_FORWARDED_HOST',
			'HTTP_MAX_FORWARDS',
			'HTTP_X_FORWARDED_SERVER',
			'REDIRECT_STATUS',
			'SERVER_PORT',
			'PATH',
			'DOCUMENT_ROOT',
			'SERVER_ADMIN',
			'QUERY_STRING',
			'PHP_SELF',
			'argv'
		);
	
	var $blogUrl = "";
	var $apiKey  = "";
	var $comment = array();
	
	
	/**
	 * Constructor
	 * 
	 * Set instance variables, connect to Akismet, and check API key
	 * 
	 * @param	String	$blogUrl	The URL to your own blog
	 * @param 	String	$apiKey		Your wordpress API key
	 * @param 	String[]	$comment	A formatted comment array to be examined by the Akismet service
	 */
	function Akismet($blogUrl, $apiKey, $comment) {
		$this->blogUrl = $blogUrl;
		$this->apiKey  = $apiKey;
		
		// Populate the comment array with information needed by Akismet
		$this->comment = $comment;
		$this->_formatCommentArray();
		
		if(!isset($this->comment['user_ip'])) {
			$this->comment['user_ip'] = ($_SERVER['REMOTE_ADDR'] != getenv('SERVER_ADDR')) ? $_SERVER['REMOTE_ADDR'] : getenv('HTTP_X_FORWARDED_FOR');
		}
		if(!isset($this->comment['user_agent'])) {
			$this->comment['user_agent'] = $_SERVER['HTTP_USER_AGENT'];
		}
		if(!isset($this->comment['referrer'])) {
			$this->comment['referrer'] = $_SERVER['HTTP_REFERER'];
		}
		$this->comment['blog'] = $blogUrl;
		
		// Connect to the Akismet server and populate errors if they exist
		$this->http = new AkismetHttpClient($this->akismetServer, $blogUrl, $apiKey);
		if($this->http->errorsExist()) {
			$this->errors = array_merge($this->errors, $this->http->getErrors());
		}
		
		// Check if the API key is valid
		if(!$this->_isValidApiKey($apiKey)) {
			$this->setError(AKISMET_INVALID_KEY, "Your Akismet API key is not valid.");
		}
	}
	
	
	/**
	 * Query the Akismet and determine if the comment is spam or not
	 * 
	 * @return	boolean
	 */
	function isSpam() {
		$response = $this->http->getResponse($this->_getQueryString(), 'comment-check');
		
		return ($response == "true");
	}
	
	
	/**
	 * Submit this comment as an unchecked spam to the Akismet server
	 * 
	 * @return	void
	 */
	function submitSpam() {
		$this->http->getResponse($this->_getQueryString(), 'submit-spam');
	}
	
	
	/**
	 * Submit a false-positive comment as "ham" to the Akismet server
	 *
	 * @return	void
	 */
	function submitHam() {
		$this->http->getResponse($this->_getQueryString(), 'submit-ham');
	}
	
	
	/**
	 * Check with the Akismet server to determine if the API key is valid
	 *
	 * @access	Protected
	 * @param	String	$key	The Wordpress API key passed from the constructor argument
	 * @return	boolean
	 */
	function _isValidApiKey($key) {
		$keyCheck = $this->http->getResponse("key=".$this->apiKey."&blog=".$this->blogUrl, 'verify-key');
			
		return ($keyCheck == "valid");
	}
	
	
	/**
	 * Format the comment array in accordance to the Akismet API
	 *
	 * @access	Protected
	 * @return	void
	 */
	function _formatCommentArray() {
		$format = array(
				'type' => 'comment_type',
				'author' => 'comment_author',
				'email' => 'comment_author_email',
				'website' => 'comment_author_url',
				'body' => 'comment_content'
			);
		
		foreach($format as $short => $long) {
			if(isset($this->comment[$short])) {
				$this->comment[$long] = $this->comment[$short];
				unset($this->comment[$short]);
			}
		}
	}
	
	
	/**
	 * Build a query string for use with HTTP requests
	 *
	 * @access	Protected
	 * @return	String
	 */
	function _getQueryString() {
		foreach($_SERVER as $key => $value) {
			if(!in_array($key, $this->ignore)) {
				if($key == 'REMOTE_ADDR') {
					$this->comment[$key] = $this->comment['user_ip'];
				} else {
					$this->comment[$key] = $value;
				}
			}
		}

		$query_string = '';

		foreach($this->comment as $key => $data) {
			$query_string .= $key . '=' . urlencode(stripslashes($data)) . '&';
		}

		return $query_string;
	}
	
	
}
?>
